<?php
/*
Plugin Name: Who is who
Plugin URI: http://zaantar.eu/index.php?page=who-is-who
Description: Přidání dodatečných informací k uživatelským profilům, umožňující jejich lepší identifikaci. <strong>Vyvinuto a určeno pro blogosphere.cz</strong>
Version: 1.0
Author: Zaantar
Author URI: http://zaantar.eu
License: GPL2
*/

/*
    Copyright 2010 Zaantar (email: zaantar@gmail.com)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License, version 2, as 
    published by the Free Software Foundation.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

/* ************************************************************************* *\
    DEFINITIONS
\* ************************************************************************* */



/* ************************************************************************* *\
    EXTRA USER FIELDS
\* ************************************************************************* */

/* wordpress hooks */
add_action( 'show_user_profile','wiw_show_user_profile' );
add_action( 'edit_user_profile','wiw_show_user_profile' );
add_action( 'personal_options_update', 'wiw_edit_user_profile' );
add_action( 'edit_user_profile_update', 'wiw_edit_user_profile' );

function wiw_show_user_profile( $user ) {
	if( !is_blog_owner( $user->ID ) ) {
		return;
	}
	?>
	<h3>Podrobnější identifikace</h3>
	<p>Tyto informace mohou být zveřejněny některým uživatelům či libovolnému návštěvníkovi - v souladu s nastavením pluginu Who is who (pro informace kontaktujte správce webu).</p>
	<table class="form-table">
    <tr>
        <th><label for="twitter">Twitter</label></th>
        <td>
            <input type="text" name="twitter" id="twitter" value="<?php echo(get_usermeta($user->ID,'twitter',true)); ?>" class="regular-text">
            <span class="description">Zadejte své uživatelské jméno z Twitteru</span>
        </td>
    </tr>
    <tr>
        <th><label for="icq">ICQ</label></th>
        <td>
            <input type="text" name="icq" id="icq" value="<?php echo(get_usermeta($user->ID,'icq',true)); ?>" class="regular-text">
            <span class="description">Pouze čísla bez pomlček</span>
        </td>
    </tr>
    <tr>
        <th><label for="cellphone">Mobilní telefon</label></th>
        <td>
            <input type="text" name="cellphone" id="cellphone" value="<?php echo(get_usermeta($user->ID,'cellphone',true)); ?>" class="regular-text">
        </td>
    </tr>
    <tr>
        <th><label for="residence">Bydliště</label></th>
        <td>
            <input type="text" name="residence" id="residence" value="<?php echo(get_usermeta($user->ID,'residence',true)); ?>" class="regular-text">
            <span class="description">Napište (i přibližně), kde bydlíte.</span>
        </td>
    </tr>
    <tr>
        <th><label for="prev_nick">Předchozí přezdívky</label></th>
        <td>
            <textarea name="prev_nick" id="prev_nick" class="regular-text"><?php echo(get_usermeta($user->ID,'prev_nick',true)); ?></textarea>
            <br><span class="description">Zadejte své minulé přezdívky oddělené čárkami</span>
        </td>
    </tr>
    <tr>
        <th><label for="prev_blogs">Předchozí blogy</label></th>
        <td>
        	<textarea name="prev_blogs" id="prev_blogs" class="regular-text"><?php echo(get_usermeta($user->ID,'prev_blogs',true)); ?></textarea>
            <br><span class="description">Zadejte adresy svých minulých blogů oddělené čárkami</span>
        </td>
    </tr>
    <tr>
        <th><label for="parallel_blogs">Paralelní blogy</label></th>
        <td>
            <textarea name="parallel_blogs" class="regular-text" id="parallel_blogs"><?php echo(get_usermeta($user->ID,'parallel_blogs',true)); ?></textarea>
            <br><span class="description">Zadejte adresy svých blogů, které používáte paralelně s tím na blogosphere.cz, oddělené čárkami</span>
        </td>
    </tr>
    </table>
	<?php
}

function wiw_edit_user_profile( $user_id ) {
	if ( !current_user_can( 'edit_user', $user_id ) ) {
		return false; 
	}
	if( !is_blog_owner( $user_id ) ) {
		return;
	}
	update_usermeta( $user_id, 'twitter', $_POST['twitter'] );
	update_usermeta( $user_id, 'icq', $_POST['icq'] );
	update_usermeta( $user_id, 'cellphone', $_POST['cellphone'] );
	update_usermeta( $user_id, 'residence', $_POST['residence'] );
	update_usermeta( $user_id, 'prev_nick', $_POST['prev_nick'] );
	update_usermeta( $user_id, 'prev_blogs', $_POST['prev_blogs'] );
	update_usermeta( $user_id, 'parallel_blogs', $_POST['parallel_blogs'] );

}

function is_blog_owner( $user_id ) {
	$owner_ids = wiw_get_blog_owner_ids();
	$is_owner = in_array( $user_id, $owner_ids );
	return $is_owner;
}

/* ************************************************************************* *\
    WHO IS WHO
\* ************************************************************************* */

add_shortcode( 'who-is-who', 'wiw_shortcode_handler' );

function wiw_shortcode_handler() {

	if( !is_blog_owner( get_current_user_id( ) ) ) {
		return '<strong>[CHYBA]</strong>: Nejste přihlášeni jako vlastník nějakého blogu na této adrese. Nemáte právo zobrazit tento obsah.';
	}
	
	$owner_ids = wiw_get_blog_owner_ids( true );
	
	$output='';
	
	foreach( $owner_ids as $oid ) {
	
		/* získání všech potřebných dat uživatele */
		$owner = get_userdata( $oid );
		
		if( substr( $owner->user_url, 0, 7 ) == 'http://' ) {
			$niceurl = substr( $owner->user_url, 7 );
		} else {
			$niceurl = $owner->user_url;
		}
		 		
		/* vypsání dat */
		$output.= '<p>';
		
		/* avatar */
		$output.= '<div class="avatar-wrapper">'.get_avatar( $oid, 32 ).'</div> ';
		
		/* jméno, adresa */
		$output.= '<strong>'.$owner->display_name.'</strong>: <a href="'.$owner->user_url.'">'.$niceurl.'</a><br>';
		$br = false;
		
		/* oficiální jméno */
		$name = '';
		if( $owner->user_firstname != '' ) {
			$name.= $owner->user_firstname;
		}
		if( $owner->user_lastname != '' ) {
			if( $name == '' ) {
				$name = $owner->user_lastname;
			} else {
				$name.= ' '.$owner->user_lastname;
			}
		}
		if( $name != '' ) {
			$output.= '<u>jméno</u>:&nbsp;'.$name.'<br>';
		}
		
		/* historie uživatele */
		$history = '';
		if( $owner->prev_nick != '' ) {
			$history.= '<u>dřívější přezdívky</u>:&nbsp;'.$owner->prev_nick.'<br>';
		}
		if( $owner->parallel_blogs != '' ) {
			$history.= '<u>paralelní blogy</u>:&nbsp;'.$owner->parallel_blogs.'<br>';
		}
		if( $owner->prev_blogs != '' ) {
			$history.= '<u>dřívější blogy</u>:&nbsp;'.$owner->prev_blogs.'<br>';
		}
		if( $history != '' ) {
			$output.= $history;
		}
		
		/* kontakty uživatele */
		$contacts = '';
		if( $owner->user_email != '' ) {
			$output.= '<u>mail</u>:&nbsp;<a href="mailto:'.$owner->user_email.'">'.$owner->user_email.'</a><br>';
		}
		if( $owner->jabber != '' ) {
			$contacts.= '<u>jab</u>:&nbsp;'.$owner->jabber.'&nbsp;'.wiw_get_jabber_status_indicator( $owner->jabber ).'; ';
		}
		if( $owner->twitter != '' ) {
			$contacts.= '<u>tw</u>:&nbsp;<a href="http://twitter.com/'.$owner->twitter.'">'.$owner->twitter.'</a>; ';
		}
		if( ( $owner->icq != '' ) && ( $owner->jabber == '' ) ) {
			$contacts.= '<u>icq</u>:&nbsp;'.$owner->icq.'&nbsp;<img style="vertical-align:middle;border:0px" src="http://web.icq.com/scripts/online.dll?icq='.$owner->icq.'&amp;img=5" alt="" />; ';
		}
		if( $owner->cellphone != '' ) {
			$contacts.= '<u>mob.</u>:&nbsp;<strong>'.$owner->cellphone.'</strong>; ';
		}
		if( $contacts != '' ) {
			$output.= $contacts.'<br>';
		}
		
		/* bydliště */
		if( $owner->residence != '' ) {
			$output.= '<u>bydliště</u>:&nbsp;'.$owner->residence.'<br>';
		}
		
		/* poznámky */
		if( $owner->user_description != '' ) {
			$output.= '<u>pozn.</u>:&nbsp;'.esc_attr( $owner->user_description ).'<br>';
		}
		
		/* zakončení */
		$output.= '</p>';
	}
	
	return $output;
}

function wiw_get_blog_owner_ids( $sort = 'false' ) {
	global $wpdb;
	$blog_ids = wiw_get_active_blog_ids( );
	
	$owner_ids = array();
	
	foreach( $blog_ids as $blog_id ) {
		/* tohle je taky pěkná prasárna */
		$query = '
			SELECT meta.user_id AS user_id, usr.display_name AS display_name
			FROM '.$wpdb->usermeta.' AS meta, '.$wpdb->users.' AS usr
			WHERE (
					( meta.meta_key LIKE "wp_'.$blog_id->blog_id.'_capabilities" ) 
				AND ( meta.meta_value LIKE "%administrator%") 
				AND ( meta.user_id = usr.ID ) 
				)
			ORDER BY usr.display_name ASC'; 
			
		$dbids = $wpdb->get_results( $query );
		foreach( $dbids as $dbid ) {
			$owner_ids[ strtolower( $dbid->display_name.'_'.$dbid->user_id ) ] = $dbid->user_id;
		}
	}
	if( $sort ) {
		ksort( $owner_ids );
	}

	return $owner_ids;
}

/* vrátí array id aktivních blogů */
function wiw_get_active_blog_ids() {
	global $wpdb;
	/* hnus, ale nevím, jak na to jinak - dokumentace k multisite toho času mizivá */
	$query = '
		SELECT DISTINCT blog_id
		FROM wp_blogs
		WHERE deleted = 0 AND archived = \'0\' AND spam = 0';
			
	$ids = $wpdb->get_results( $wpdb->prepare( $query ) );
	
	return $ids;
}

function wiw_get_jabber_status_indicator( $jid ) {
	$jidex = explode( '@', $jid );
	if( !isset( $jidex[1] ) ) {
		return '';
	}
	$server = $jidex[1];
	
	switch( $server ) {
		case 'jabbim.com':
		case 'jabbim.sk':
		case 'jabbim.pl':
		case 'jabbim.cz':
		case 'jabber.cz':
		case 'njs.netlab.cz':
		case 'jabster.pl':
		case 'jabber.root.cz':
			return '<img style="vertical-align:middle;border:0px" src="http://netlab.cz/status/?jid='.$jid.'&ib=psi"/>';
			break;
		case 'gmail.com':
		default:
			return '';
			break;
	}
}
?>
